/***********************************************************
 *                                                         *
 *  config.h                                               *
 *  Autor: Pier Paolo Guillen Hernandez                    *
 *         Aguascalientes, Ags.                            *
 *  Fecha: Marzo 2004 - Abril 2008                         *
 *                                                         *
 *  Objetivo: Header con las funciones de inicio y fin.    *
 *                                                         *
 ***********************************************************/
 
#ifndef CONFIG_H
#define CONFIG_H

// Ruta de los archivos .dat
#define INTRO_FILE            "data/intro.dat"
#define ENDING_FILE           "data/credits.dat"
#define TANKS_FILE            "data/tanks.dat"
#define ARMAMENT_FILE         "data/armament.dat"
#define BACKGROUND_FILE       "data/backgrounds.dat"
#define FONTS_FILE            "data/fonts.dat"
#define SOUND_FILE            "data/fx.dat"
#define RANKING_FILE          "data/ranking.dat"
#define SCREENS_FILE          "data/screens.dat"
#define BATTLE_FILE           "programs/precal.dat"
#define PLAYERS_FILE          "programs/players.txt"
#define RESULTS_FILE          "programs/resultados.txt"

// Ruta de las canciones
#define INTRO_SONG            "music/intro.mp3"
#define RANKING_SONG          "music/ranking.mp3"
#define ENDING_SONG           "music/credits.mp3"

// Declaramos funciones
void libraries_init(void);
void libraries_exit(void);

#endif

