/***********************************************************
 *                                                         *
 *  fade.h                                                 *
 *  Autor: Pier Paolo Guillen Hernandez                    *
 *         Aguascalientes, Ags.                            *
 *  Fecha: Marzo 2004 - Abril 2008                         *
 *                                                         *
 *  Objetivo: Headers para los fades.                      *
 *                                                         *
 ***********************************************************/

#ifndef FADE_H
#define FADE_H

// Librerias a incluir
#include "allegro.h"

// Constantes
#define MAX_TRANS_VALUE    255                           // Valor maximo que se puede usar como transparencia
#define MAX_VOLUME_VALUE   255                           // Valor maximo que se puede usar como transparencia

// Definimos funciones
void fade_from_color(BITMAP *, int, int, int, int);      // Fade de entrada (de color a imagen)
void fade_to_color(BITMAP *, int, int, int, int);        // Fade de salida (de imagen a color)
void fade_music_in(int);                                 // Entra la musica con fade
void fade_music_out(int);                                // Sale la musica con fade
void fade_media_in (BITMAP *, int, int, int, int);       // Entra la musica y la imagen con fade
void fade_media_out (BITMAP *, int, int, int, int);      // Sale la musica y la imagen con fade

#endif
